OGRE: Ogre::Renderable Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::Renderable Class Referenceabstract
Core » Scene

Abstract class defining the interface all renderable objects must implement. More...

`#include <OgreRenderable.h>`

Inheritance diagram for Ogre::Renderable:
[legend]

## Classes
class | Visitor
| Visitor object that can be used to iterate over a collection of Renderable instances abstractly. More...

## Public Types
enum | { DEFAULT_PRIORITY = 100 }

## Public Member Functions
| Renderable ()
virtual | ~Renderable ()
| Virtual destructor needed as class has virtual methods.
uint16 | _getMaterialLodIndex () const
virtual void | _updateCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
virtual bool | getCastsShadows (void) const
| Method which reports whether this renderable would normally cast a shadow.
const Vector4f & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
virtual const LightList & | getLights (void) const =0
| Gets a list of lights, ordered relative to how close they are to this renderable.
virtual const MaterialPtr & | getMaterial (void) const =0
| Retrieves a weak reference to the material this renderable object uses.
virtual uint16 | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires.
bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual void | getRenderOperation (RenderOperation &op)=0
| Gets the render operation required to send this object to the frame buffer.
virtual Real | getSquaredViewDepth (const Camera *cam) const =0
| Returns the squared distance between the camera and this renderable.
virtual Technique * | getTechnique (void) const
| Retrieves a pointer to the Material Technique this renderable object uses.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual void | getWorldTransforms (Matrix4 *xform) const =0
| Gets the world transform matrix / matrices for this renderable object.
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index.
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered.
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index.
void | setCustomParameter (size_t index, const Vector4f &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
void | setUserAny (const Any &anything)

## Detailed Description

Abstract class defining the interface all renderable objects must implement.

This interface abstracts renderable discrete objects which will be queued in the render pipeline, grouped by material. Classes implementing this interface must be based on a single material, a single world matrix (or a collection of world matrices which are blended by weights), and must be renderable via a single render operation.

  Note that deciding whether to put these objects in the rendering pipeline is done from the more specific classes e.g. entities. Only once it is decided that the specific class is to be rendered is the abstract version created (could be more than one per visible object) and pushed onto the rendering queue.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

Enumerator
DEFAULT_PRIORITY |

## Constructor & Destructor Documentation

## ◆ Renderable()

Ogre::Renderable::Renderable | ( |  | ) |
| inline

Referenced by Ogre::Renderable::Visitor::visit().

## ◆ ~Renderable()

virtual Ogre::Renderable::~Renderable | ( |  | ) |
| inlinevirtual

Virtual destructor needed as class has virtual methods.

## Member Function Documentation

## ◆ getMaterial()

virtual const MaterialPtr & Ogre::Renderable::getMaterial | ( | void |  | ) | const
| pure virtual

Retrieves a weak reference to the material this renderable object uses.

Note that the Renderable also has the option to override the getTechnique method to specify a particular Technique to use instead of the best one available.

Implemented in Ogre::BillboardChain, Ogre::BillboardSet, Ogre::BorderRenderable, Ogre::BspLevel, Ogre::InstanceBatch, Ogre::ManualObject::ManualObjectSection, Ogre::OverlayElement, Ogre::ShadowRenderable, Ogre::SimpleRenderable, Ogre::StaticGeometry::GeometryBucket, Ogre::SubEntity, and Ogre::TextAreaOverlayElement.

Referenced by getTechnique().

## ◆ getTechnique()

virtual Technique * Ogre::Renderable::getTechnique | ( | void |  | ) | const
| inlinevirtual

Retrieves a pointer to the Material Technique this renderable object uses.

This is to allow Renderables to use a chosen Technique if they wish, otherwise they will use the best Technique available for the Material they are using.

Reimplemented in Ogre::StaticGeometry::GeometryBucket.

References getMaterial().

## ◆ getRenderOperation()

virtual void Ogre::Renderable::getRenderOperation | ( | RenderOperation & | op | ) |
| pure virtual

Gets the render operation required to send this object to the frame buffer.

Implemented in Ogre::BillboardChain, Ogre::BillboardSet, Ogre::BorderRenderable, Ogre::BspLevel, Ogre::InstanceBatch, Ogre::ManualObject::ManualObjectSection, Ogre::PanelOverlayElement, Ogre::ShadowRenderable, Ogre::SimpleRenderable, Ogre::StaticGeometry::GeometryBucket, Ogre::SubEntity, and Ogre::TextAreaOverlayElement.

## ◆ _getMaterialLodIndex()

uint16 Ogre::Renderable::_getMaterialLodIndex | ( |  | ) | const
| inline

## ◆ preRender()

virtual bool Ogre::Renderable::preRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys )
| inlinevirtual

Called just prior to the Renderable being rendered.

OGRE is a queued renderer, so the actual render commands are executed at a later time than the point at which an object is discovered to be visible. This allows ordering & grouping of renders without the discovery process having to be aware of it. It also means OGRE uses declarative render information rather than immediate mode rendering - this is very useful in that certain effects and processes can automatically be applied to a wide range of scenes, but the downside is that special cases are more difficult to handle, because there is not the declared state to cope with it.

  This method allows a Renderable to do something special at the actual point of rendering if it wishes to. When this method is called, all the material render state as declared by this Renderable has already been set, all that is left to do is to bind the buffers and perform the render. The Renderable may modify render state itself if it wants to (and restore it in the postRender call) before the automated render happens, or by returning 'false' from this method can actually suppress the automatic render and perform one of its own.

Returns
  true if the automatic render should proceed, false to skip it on the assumption that the Renderable has done it manually.

Reimplemented in Ogre::BillboardChain.

## ◆ postRender()

virtual void Ogre::Renderable::postRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys )
| inlinevirtual

Called immediately after the Renderable has been rendered.

## ◆ getWorldTransforms()

virtual void Ogre::Renderable::getWorldTransforms | ( | Matrix4 * | xform | ) | const
| pure virtual

Gets the world transform matrix / matrices for this renderable object.

If the object has any derived transforms, these are expected to be up to date as long as all the SceneNode structures have been updated before this is called.

Note
  Internal Ogre never supports non-affine matrix for world transform matrix/matrices, the behavior is undefined if returns non-affine matrix here.

This method will populate transform with 1 matrix if it does not use GPU vertex blending. If it does use GPU vertex blending it will fill the passed in pointer with an array of matrices, the length being the value returned from getNumWorldTransforms.

Note
  If MeshManager::getBonesUseObjectSpace() is true, the first matrix must contain the world transform of the object, and the rest of the matrices must contain the bone transforms in object space.

Implemented in Ogre::BaseInstanceBatchVTF, Ogre::BillboardChain, Ogre::BillboardSet, Ogre::BorderRenderable, Ogre::BspLevel, Ogre::InstanceBatchHW, Ogre::InstanceBatchShader, Ogre::ManualObject::ManualObjectSection, Ogre::OverlayElement, Ogre::ShadowRenderable, Ogre::SimpleRenderable, Ogre::StaticGeometry::GeometryBucket, and Ogre::SubEntity.

## ◆ getNumWorldTransforms()

virtual uint16 Ogre::Renderable::getNumWorldTransforms | ( | void |  | ) | const
| inlinevirtual

Returns the number of world transform matrices this renderable requires.

When a renderable uses GPU vertex blending, it uses multiple world matrices instead of a single one. Each vertex sent to the pipeline can reference one or more matrices in this list with given weights. If a renderable does not use vertex blending this method returns 1, which is the default for simplicity.

Note
  If MeshManager::getBonesUseObjectSpace() is true, this method must return numBones + 1

Reimplemented in Ogre::BorderRenderable, Ogre::InstanceBatchShader, and Ogre::SubEntity.

## ◆ setUseIdentityProjection()

void Ogre::Renderable::setUseIdentityProjection | ( | bool | useIdentityProjection | ) |
| inline

Sets whether or not to use an 'identity' projection.

Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also
  Renderable::getUseIdentityProjection

## ◆ getUseIdentityProjection()

bool Ogre::Renderable::getUseIdentityProjection | ( | void |  | ) | const
| inline

Returns whether or not to use an 'identity' projection.

Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this.

See also
  Renderable::setUseIdentityProjection

## ◆ setUseIdentityView()

void Ogre::Renderable::setUseIdentityView | ( | bool | useIdentityView | ) |
| inline

Sets whether or not to use an 'identity' view.

Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also
  Renderable::getUseIdentityView

## ◆ getUseIdentityView()

bool Ogre::Renderable::getUseIdentityView | ( | void |  | ) | const
| inline

Returns whether or not to use an 'identity' view.

Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this.

See also
  Renderable::setUseIdentityView

## ◆ getSquaredViewDepth()

virtual Real Ogre::Renderable::getSquaredViewDepth | ( | const Camera * | cam | ) | const
| pure virtual

Returns the squared distance between the camera and this renderable.

Used to sort transparent objects. Squared distance is used to avoid having to perform a square root on the result.

Implemented in Ogre::BillboardChain, Ogre::BillboardSet, Ogre::BorderRenderable, Ogre::BspLevel, Ogre::InstanceBatch, Ogre::ManualObject::ManualObjectSection, Ogre::OverlayElement, Ogre::Rectangle2D, Ogre::ShadowRenderable, Ogre::StaticGeometry::GeometryBucket, Ogre::SubEntity, Ogre::Volume::Chunk, and Ogre::WireBoundingBox.

## ◆ getLights()

virtual const LightList & Ogre::Renderable::getLights | ( | void |  | ) | const
| pure virtual

Gets a list of lights, ordered relative to how close they are to this renderable.

Directional lights, which have no position, will always be first on this list.

Implemented in Ogre::BillboardChain, Ogre::BillboardSet, Ogre::BorderRenderable, Ogre::BspLevel, Ogre::InstanceBatch, Ogre::ManualObject::ManualObjectSection, Ogre::OverlayElement, Ogre::ShadowRenderable, Ogre::SimpleRenderable, Ogre::StaticGeometry::GeometryBucket, and Ogre::SubEntity.

## ◆ getCastsShadows()

virtual bool Ogre::Renderable::getCastsShadows | ( | void |  | ) | const
| inlinevirtual

Method which reports whether this renderable would normally cast a shadow.

Subclasses should override this if they could have been used to generate a shadow.

Reimplemented in Ogre::StaticGeometry::GeometryBucket, and Ogre::SubEntity.

## ◆ setCustomParameter()

void Ogre::Renderable::setCustomParameter | ( | size_t | index,
|  | const Vector4f & | value )

Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.

Calling this method simply associates a numeric index with a 4-dimensional value for this specific Renderable. This is most useful if the material which this Renderable uses a vertex or fragment program, and has an ACT_CUSTOM parameter entry. This parameter entry can refer to the index you specify as part of this call, thereby mapping a custom parameter for this renderable to a program parameter.

Parameters

  index | The index with which to associate the value. Note that this does not have to start at 0, and can include gaps. It also has no direct correlation with a GPU program parameter index - the mapping between the two is performed by the ACT_CUSTOM entry, if that is used.
  value | The value to associate.

## ◆ removeCustomParameter()

void Ogre::Renderable::removeCustomParameter | ( | size_t | index | ) |

Removes a custom value which is associated with this Renderable at the given index.

Parameters

  index | Index of the parameter to remove.

See also
  setCustomParameter for full details.

## ◆ hasCustomParameter()

bool Ogre::Renderable::hasCustomParameter | ( | size_t | index | ) | const

Checks whether a custom value is associated with this Renderable at the given index.

Parameters

  index | Index of the parameter to check for existence.

See also
  setCustomParameter for full details.

## ◆ getCustomParameter()

const Vector4f & Ogre::Renderable::getCustomParameter | ( | size_t | index | ) | const

Gets the custom value associated with this Renderable at the given index.

Parameters

  index | Index of the parameter to retrieve.

See also
  setCustomParameter for full details.

## ◆ _updateCustomGpuParameter()

virtual void Ogre::Renderable::_updateCustomGpuParameter | ( | const GpuProgramParameters::AutoConstantEntry & | constantEntry,
|  | GpuProgramParameters * | params ) const
| virtual

Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.

This method allows a Renderable to map in a custom GPU program parameter based on it's own data. This is represented by a GPU auto parameter of ACT_CUSTOM, and to allow there to be more than one of these per Renderable, the 'data' field on the auto parameter will identify which parameter is being updated. The implementation of this method must identify the parameter being updated, and call a 'setConstant' method on the passed in GpuProgramParameters object, using the details provided in the incoming auto constant setting to identify the index at which to set the parameter.

  You do not need to override this method if you're using the standard sets of data associated with the Renderable as provided by setCustomParameter and getCustomParameter. By default, the implementation will map from the value indexed by the 'constantEntry.data' parameter to a value previously set by setCustomParameter. But custom Renderables are free to override this if they want, in any case.

Parameters

  constantEntry | The auto constant entry referring to the parameter being updated
  params | The parameters object which this method should call to set the updated parameters.

Reimplemented in Ogre::SubEntity.

## ◆ setPolygonModeOverrideable()

void Ogre::Renderable::setPolygonModeOverrideable | ( | bool | override | ) |
| inline

Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Parameters

  override | true means that a lower camera detail will override this renderables detail level, false means it won't.

## ◆ getPolygonModeOverrideable()

bool Ogre::Renderable::getPolygonModeOverrideable | ( | void |  | ) | const
| inline

Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Referenced by Ogre::BorderRenderable::BorderRenderable().

## ◆ setUserAny()

void Ogre::Renderable::setUserAny | ( | const Any & | anything | ) |
| inline

Deprecated
  use UserObjectBindings::setUserAny via getUserObjectBindings() instead.

References getUserObjectBindings().

Referenced by Ogre::InstanceBatch::visitRenderables().

## ◆ getUserAny()

const Any & Ogre::Renderable::getUserAny | ( | void |  | ) | const
| inline

Deprecated
  use UserObjectBindings::getUserAny via getUserObjectBindings() instead.

References getUserObjectBindings().

Referenced by Ogre::InstanceBatch::visitRenderables().

## ◆ getUserObjectBindings() [1/2]

UserObjectBindings & Ogre::Renderable::getUserObjectBindings | ( |  | ) |
| inline

Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.

Referenced by getUserAny(), and setUserAny().

## ◆ getUserObjectBindings() [2/2]

const UserObjectBindings & Ogre::Renderable::getUserObjectBindings | ( |  | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

The documentation for this class was generated from the following file:

- OgreRenderable.h